From a466930858ab34168ffaba69b056ad9752c23db3 Mon Sep 17 00:00:00 2001
From: Felix Fietkau <nbd@openwrt.org>
Date: Sat, 12 Jul 2008 22:24:26 +0000
Subject: madwifi: drop stale AP nodes from the client list when disconnecting.
 Fixes some reassoc issues.

SVN-Revision: 11797
---
 package/madwifi/patches/360-sta_nodes.patch | 59 +++++++++++++++++++++++++++++
 1 file changed, 59 insertions(+)
 create mode 100644 package/madwifi/patches/360-sta_nodes.patch

(limited to 'package/madwifi/patches/360-sta_nodes.patch')

diff --git a/package/madwifi/patches/360-sta_nodes.patch b/package/madwifi/patches/360-sta_nodes.patch
new file mode 100644
index 0000000000..4f70b5712d
--- /dev/null
+++ b/package/madwifi/patches/360-sta_nodes.patch
@@ -0,0 +1,59 @@
+Drop stale AP nodes from the client list when disconnecting.
+Fixes some reassoc issues.
+
+Signed-off-by: Felix Fietkau <nbd@openwrt.org>
+
+--- a/net80211/ieee80211_proto.c
++++ b/net80211/ieee80211_proto.c
+@@ -1348,7 +1348,7 @@
+ 				IEEE80211_SEND_MGMT(ni,
+ 					IEEE80211_FC0_SUBTYPE_DISASSOC,
+ 					IEEE80211_REASON_ASSOC_LEAVE);
+-				ieee80211_sta_leave(ni);
++				ieee80211_node_leave(ni);
+ 				break;
+ 			case IEEE80211_M_HOSTAP:
+ 				ieee80211_iterate_nodes(&ic->ic_sta,
+@@ -1358,6 +1358,7 @@
+ 				break;
+ 			}
+ 			goto reset;
++		case IEEE80211_S_AUTH:
+ 		case IEEE80211_S_ASSOC:
+ 			switch (vap->iv_opmode) {
+ 			case IEEE80211_M_STA:
+@@ -1376,7 +1377,6 @@
+ 		case IEEE80211_S_SCAN:
+ 			ieee80211_cancel_scan(vap);
+ 			goto reset;
+-		case IEEE80211_S_AUTH:
+ 		reset:
+ 			ieee80211_reset_bss(vap);
+ 			break;
+@@ -1432,7 +1432,7 @@
+ 			break;
+ 		case IEEE80211_S_RUN:		/* beacon miss */
+ 			if (vap->iv_opmode == IEEE80211_M_STA) {
+-				ieee80211_sta_leave(ni);
++				ieee80211_node_leave(ni);
+ 				vap->iv_flags &= ~IEEE80211_F_SIBSS;	/* XXX */
+ 				if (ic->ic_roaming == IEEE80211_ROAMING_AUTO)
+ 					ieee80211_check_scan(vap,
+@@ -1483,7 +1483,7 @@
+ 				vap->iv_state = ostate;	/* stay RUN */
+ 				break;
+ 			case IEEE80211_FC0_SUBTYPE_DEAUTH:
+-				ieee80211_sta_leave(ni);
++				ieee80211_node_leave(ni);
+ 				if (ic->ic_roaming == IEEE80211_ROAMING_AUTO) {
+ 					/* try to reauth */
+ 					IEEE80211_SEND_MGMT(ni,
+@@ -1510,7 +1510,7 @@
+ 				IEEE80211_FC0_SUBTYPE_ASSOC_REQ, 0);
+ 			break;
+ 		case IEEE80211_S_RUN:
+-			ieee80211_sta_leave(ni);
++			ieee80211_node_leave(ni);
+ 			if (ic->ic_roaming == IEEE80211_ROAMING_AUTO) {
+ 				/* NB: caller specifies ASSOC/REASSOC by arg */
+ 				IEEE80211_SEND_MGMT(ni, arg ?
-- 
cgit v1.2.3

c5082b82a30c9'>tree</a><a href='/cgit.cgi/openwrt/upstream/commit/target/linux/bcm27xx/patches-5.10/950-0490-media-i2c-imx477-Replace-existing-1012x760-mode.patch?h=v22.03.0-rc6&amp;id=8299d1f057439f94c6a4412e2e5c5082b82a30c9'>commit</a><a href='/cgit.cgi/openwrt/upstream/diff/target/linux/bcm27xx/patches-5.10/950-0490-media-i2c-imx477-Replace-existing-1012x760-mode.patch?h=v22.03.0-rc6&amp;id=8299d1f057439f94c6a4412e2e5c5082b82a30c9'>diff</a><a href='/cgit.cgi/openwrt/upstream/stats/target/linux/bcm27xx/patches-5.10/950-0490-media-i2c-imx477-Replace-existing-1012x760-mode.patch?h=v22.03.0-rc6'>stats</a></td><td class='form'><form class='right' method='get' action='/cgit.cgi/openwrt/upstream/log/target/linux/bcm27xx/patches-5.10/950-0490-media-i2c-imx477-Replace-existing-1012x760-mode.patch'>
<input type='hidden' name='h' value='v22.03.0-rc6'/><input type='hidden' name='id' value='8299d1f057439f94c6a4412e2e5c5082b82a30c9'/><select name='qt'>
<option value='grep'>log msg</option>
<option value='author'>author</option>
<option value='committer'>committer</option>
<option value='range'>range</option>
</select>
<input class='txt' type='search' size='10' name='q' value=''/>
<input type='submit' value='search'/>
</form>
</td></tr></table>
<div class='path'>path: <a href='/cgit.cgi/openwrt/upstream/tree/?h=v22.03.0-rc6&amp;id=8299d1f057439f94c6a4412e2e5c5082b82a30c9'>root</a>/<a href='/cgit.cgi/openwrt/upstream/tree/target?h=v22.03.0-rc6&amp;id=8299d1f057439f94c6a4412e2e5c5082b82a30c9'>target</a>/<a href='/cgit.cgi/openwrt/upstream/tree/target/linux?h=v22.03.0-rc6&amp;id=8299d1f057439f94c6a4412e2e5c5082b82a30c9'>linux</a>/<a href='/cgit.cgi/openwrt/upstream/tree/target/linux/bcm27xx?h=v22.03.0-rc6&amp;id=8299d1f057439f94c6a4412e2e5c5082b82a30c9'>bcm27xx</a>/<a href='/cgit.cgi/openwrt/upstream/tree/target/linux/bcm27xx/patches-5.10?h=v22.03.0-rc6&amp;id=8299d1f057439f94c6a4412e2e5c5082b82a30c9'>patches-5.10</a>/<a href='/cgit.cgi/openwrt/upstream/tree/target/linux/bcm27xx/patches-5.10/950-0490-media-i2c-imx477-Replace-existing-1012x760-mode.patch?h=v22.03.0-rc6&amp;id=8299d1f057439f94c6a4412e2e5c5082b82a30c9'>950-0490-media-i2c-imx477-Replace-existing-1012x760-mode.patch</a></div><div class='content'>blob: 512cd6ae54dc2254af9816d79f9d25039ff546a9 (<a href='/cgit.cgi/openwrt/upstream/plain/target/linux/bcm27xx/patches-5.10/950-0490-media-i2c-imx477-Replace-existing-1012x760-mode.patch?h=v22.03.0-rc6&amp;id=8299d1f057439f94c6a4412e2e5c5082b82a30c9'>plain</a>)
<table summary='blob content' class='blob'>
<tr><td class='linenumbers'><pre><a id='n1' href='#n1'>1</a>
<a id='n2' href='#n2'>2</a>
<a id='n3' href='#n3'>3</a>
<a id='n4' href='#n4'>4</a>
<a id='n5' href='#n5'>5</a>
<a id='n6' href='#n6'>6</a>
<a id='n7' href='#n7'>7</a>
<a id='n8' href='#n8'>8</a>
<a id='n9' href='#n9'>9</a>
<a id='n10' href='#n10'>10</a>
<a id='n11' href='#n11'>11</a>
<a id='n12' href='#n12'>12</a>
<a id='n13' href='#n13'>13</a>
<a id='n14' href='#n14'>14</a>
<a id='n15' href='#n15'>15</a>
<a id='n16' href='#n16'>16</a>
<a id='n17' href='#n17'>17</a>
<a id='n18' href='#n18'>18</a>
<a id='n19' href='#n19'>19</a>
<a id='n20' href='#n20'>20</a>
<a id='n21' href='#n21'>21</a>
<a id='n22' href='#n22'>22</a>
<a id='n23' href='#n23'>23</a>
<a id='n24' href='#n24'>24</a>
<a id='n25' href='#n25'>25</a>
<a id='n26' href='#n26'>26</a>
<a id='n27' href='#n27'>27</a>
<a id='n28' href='#n28'>28</a>
<a id='n29' href='#n29'>29</a>
<a id='n30' href='#n30'>30</a>
<a id='n31' href='#n31'>31</a>
<a id='n32' href='#n32'>32</a>
<a id='n33' href='#n33'>33</a>
<a id='n34' href='#n34'>34</a>
<a id='n35' href='#n35'>35</a>
<a id='n36' href='#n36'>36</a>
<a id='n37' href='#n37'>37</a>
<a id='n38' href='#n38'>38</a>
<a id='n39' href='#n39'>39</a>
<a id='n40' href='#n40'>40</a>
<a id='n41' href='#n41'>41</a>
<a id='n42' href='#n42'>42</a>
<a id='n43' href='#n43'>43</a>
<a id='n44' href='#n44'>44</a>
<a id='n45' href='#n45'>45</a>
<a id='n46' href='#n46'>46</a>
<a id='n47' href='#n47'>47</a>
<a id='n48' href='#n48'>48</a>
<a id='n49' href='#n49'>49</a>
<a id='n50' href='#n50'>50</a>
<a id='n51' href='#n51'>51</a>
<a id='n52' href='#n52'>52</a>
<a id='n53' href='#n53'>53</a>
<a id='n54' href='#n54'>54</a>
<a id='n55' href='#n55'>55</a>
<a id='n56' href='#n56'>56</a>
<a id='n57' href='#n57'>57</a>
<a id='n58' href='#n58'>58</a>
<a id='n59' href='#n59'>59</a>
<a id='n60' href='#n60'>60</a>
<a id='n61' href='#n61'>61</a>
<a id='n62' href='#n62'>62</a>
<a id='n63' href='#n63'>63</a>
<a id='n64' href='#n64'>64</a>
<a id='n65' href='#n65'>65</a>
<a id='n66' href='#n66'>66</a>
<a id='n67' href='#n67'>67</a>
<a id='n68' href='#n68'>68</a>
<a id='n69' href='#n69'>69</a>
<a id='n70' href='#n70'>70</a>
<a id='n71' href='#n71'>71</a>
<a id='n72' href='#n72'>72</a>
<a id='n73' href='#n73'>73</a>
<a id='n74' href='#n74'>74</a>
<a id='n75' href='#n75'>75</a>
<a id='n76' href='#n76'>76</a>
<a id='n77' href='#n77'>77</a>
<a id='n78' href='#n78'>78</a>
<a id='n79' href='#n79'>79</a>
<a id='n80' href='#n80'>80</a>
<a id='n81' href='#n81'>81</a>
<a id='n82' href='#n82'>82</a>
<a id='n83' href='#n83'>83</a>
<a id='n84' href='#n84'>84</a>
<a id='n85' href='#n85'>85</a>
<a id='n86' href='#n86'>86</a>
<a id='n87' href='#n87'>87</a>
<a id='n88' href='#n88'>88</a>
<a id='n89' href='#n89'>89</a>
<a id='n90' href='#n90'>90</a>
<a id='n91' href='#n91'>91</a>
<a id='n92' href='#n92'>92</a>
<a id='n93' href='#n93'>93</a>
<a id='n94' href='#n94'>94</a>
<a id='n95' href='#n95'>95</a>
<a id='n96' href='#n96'>96</a>
<a id='n97' href='#n97'>97</a>
<a id='n98' href='#n98'>98</a>
<a id='n99' href='#n99'>99</a>
<a id='n100' href='#n100'>100</a>
<a id='n101' href='#n101'>101</a>
<a id='n102' href='#n102'>102</a>
<a id='n103' href='#n103'>103</a>
<a id='n104' href='#n104'>104</a>
<a id='n105' href='#n105'>105</a>
<a id='n106' href='#n106'>106</a>
<a id='n107' href='#n107'>107</a>
<a id='n108' href='#n108'>108</a>
<a id='n109' href='#n109'>109</a>
<a id='n110' href='#n110'>110</a>
<a id='n111' href='#n111'>111</a>
<a id='n112' href='#n112'>112</a>
<a id='n113' href='#n113'>113</a>
<a id='n114' href='#n114'>114</a>
<a id='n115' href='#n115'>115</a>
<a id='n116' href='#n116'>116</a>
<a id='n117' href='#n117'>117</a>
<a id='n118' href='#n118'>118</a>
<a id='n119' href='#n119'>119</a>
<a id='n120' href='#n120'>120</a>
<a id='n121' href='#n121'>121</a>
<a id='n122' href='#n122'>122</a>
<a id='n123' href='#n123'>123</a>
<a id='n124' href='#n124'>124</a>
<a id='n125' href='#n125'>125</a>
<a id='n126' href='#n126'>126</a>
<a id='n127' href='#n127'>127</a>
<a id='n128' href='#n128'>128</a>
<a id='n129' href='#n129'>129</a>
<a id='n130' href='#n130'>130</a>
<a id='n131' href='#n131'>131</a>
<a id='n132' href='#n132'>132</a>
<a id='n133' href='#n133'>133</a>
<a id='n134' href='#n134'>134</a>
<a id='n135' href='#n135'>135</a>
<a id='n136' href='#n136'>136</a>
<a id='n137' href='#n137'>137</a>
<a id='n138' href='#n138'>138</a>
<a id='n139' href='#n139'>139</a>
<a id='n140' href='#n140'>140</a>
<a id='n141' href='#n141'>141</a>
<a id='n142' href='#n142'>142</a>
<a id='n143' href='#n143'>143</a>
<a id='n144' href='#n144'>144</a>
<a id='n145' href='#n145'>145</a>
<a id='n146' href='#n146'>146</a>
<a id='n147' href='#n147'>147</a>
<a id='n148' href='#n148'>148</a>
<a id='n149' href='#n149'>149</a>
<a id='n150' href='#n150'>150</a>
<a id='n151' href='#n151'>151</a>
<a id='n152' href='#n152'>152</a>
<a id='n153' href='#n153'>153</a>
<a id='n154' href='#n154'>154</a>
<a id='n155' href='#n155'>155</a>
<a id='n156' href='#n156'>156</a>
<a id='n157' href='#n157'>157</a>
<a id='n158' href='#n158'>158</a>
<a id='n159' href='#n159'>159</a>
<a id='n160' href='#n160'>160</a>
<a id='n161' href='#n161'>161</a>
<a id='n162' href='#n162'>162</a>
<a id='n163' href='#n163'>163</a>
<a id='n164' href='#n164'>164</a>
<a id='n165' href='#n165'>165</a>
<a id='n166' href='#n166'>166</a>
<a id='n167' href='#n167'>167</a>
<a id='n168' href='#n168'>168</a>
<a id='n169' href='#n169'>169</a>
<a id='n170' href='#n170'>170</a>
<a id='n171' href='#n171'>171</a>
<a id='n172' href='#n172'>172</a>
<a id='n173' href='#n173'>173</a>
<a id='n174' href='#n174'>174</a>
<a id='n175' href='#n175'>175</a>
<a id='n176' href='#n176'>176</a>
<a id='n177' href='#n177'>177</a>
<a id='n178' href='#n178'>178</a>
<a id='n179' href='#n179'>179</a>
<a id='n180' href='#n180'>180</a>
<a id='n181' href='#n181'>181</a>
<a id='n182' href='#n182'>182</a>
<a id='n183' href='#n183'>183</a>
<a id='n184' href='#n184'>184</a>
<a id='n185' href='#n185'>185</a>
<a id='n186' href='#n186'>186</a>
<a id='n187' href='#n187'>187</a>
<a id='n188' href='#n188'>188</a>
<a id='n189' href='#n189'>189</a>
<a id='n190' href='#n190'>190</a>
<a id='n191' href='#n191'>191</a>
<a id='n192' href='#n192'>192</a>
<a id='n193' href='#n193'>193</a>
<a id='n194' href='#n194'>194</a>
<a id='n195' href='#n195'>195</a>
<a id='n196' href='#n196'>196</a>
<a id='n197' href='#n197'>197</a>
</pre></td>
<td class='lines'><pre><code><style>pre { line-height: 125%; margin: 0; }
td.linenos pre { color: #000000; background-color: #f0f0f0; padding: 0 5px 0 5px; }
span.linenos { color: #000000; background-color: #f0f0f0; padding: 0 5px 0 5px; }
td.linenos pre.special { color: #000000; background-color: #ffffc0; padding: 0 5px 0 5px; }
span.linenos.special { color: #000000; background-color: #ffffc0; padding: 0 5px 0 5px; }
.highlight .hll { background-color: #ffffcc }
.highlight { background: #ffffff; }
.highlight .c { color: #888888 } /* Comment */
.highlight .err { color: #a61717; background-color: #e3d2d2 } /* Error */
.highlight .k { color: #008800; font-weight: bold } /* Keyword */
.highlight .ch { color: #888888 } /* Comment.Hashbang */
.highlight .cm { color: #888888 } /* Comment.Multiline */
.highlight .cp { color: #cc0000; font-weight: bold } /* Comment.Preproc */
.highlight .cpf { color: #888888 } /* Comment.PreprocFile */
.highlight .c1 { color: #888888 } /* Comment.Single */
.highlight .cs { color: #cc0000; font-weight: bold; background-color: #fff0f0 } /* Comment.Special */
.highlight .gd { color: #000000; background-color: #ffdddd } /* Generic.Deleted */
.highlight .ge { font-style: italic } /* Generic.Emph */
.highlight .gr { color: #aa0000 } /* Generic.Error */
.highlight .gh { color: #333333 } /* Generic.Heading */
.highlight .gi { color: #000000; background-color: #ddffdd } /* Generic.Inserted */
.highlight .go { color: #888888 } /* Generic.Output */
.highlight .gp { color: #555555 } /* Generic.Prompt */
.highlight .gs { font-weight: bold } /* Generic.Strong */
.highlight .gu { color: #666666 } /* Generic.Subheading */
.highlight .gt { color: #aa0000 } /* Generic.Traceback */
.highlight .kc { color: #008800; font-weight: bold } /* Keyword.Constant */
.highlight .kd { color: #008800; font-weight: bold } /* Keyword.Declaration */
.highlight .kn { color: #008800; font-weight: bold } /* Keyword.Namespace */
.highlight .kp { color: #008800 } /* Keyword.Pseudo */
.highlight .kr { color: #008800; font-weight: bold } /* Keyword.Reserved */
.highlight .kt { color: #888888; font-weight: bold } /* Keyword.Type */
.highlight .m { color: #0000DD; font-weight: bold } /* Literal.Number */
.highlight .s { color: #dd2200; background-color: #fff0f0 } /* Literal.String */
.highlight .na { color: #336699 } /* Name.Attribute */
.highlight .nb { color: #003388 } /* Name.Builtin */
.highlight .nc { color: #bb0066; font-weight: bold } /* Name.Class */
.highlight .no { color: #003366; font-weight: bold } /* Name.Constant */
.highlight .nd { color: #555555 } /* Name.Decorator */
.highlight .ne { color: #bb0066; font-weight: bold } /* Name.Exception */
.highlight .nf { color: #0066bb; font-weight: bold } /* Name.Function */
.highlight .nl { color: #336699; font-style: italic } /* Name.Label */
.highlight .nn { color: #bb0066; font-weight: bold } /* Name.Namespace */
.highlight .py { color: #336699; font-weight: bold } /* Name.Property */
.highlight .nt { color: #bb0066; font-weight: bold } /* Name.Tag */
.highlight .nv { color: #336699 } /* Name.Variable */
.highlight .ow { color: #008800 } /* Operator.Word */
.highlight .w { color: #bbbbbb } /* Text.Whitespace */
.highlight .mb { color: #0000DD; font-weight: bold } /* Literal.Number.Bin */
.highlight .mf { color: #0000DD; font-weight: bold } /* Literal.Number.Float */
.highlight .mh { color: #0000DD; font-weight: bold } /* Literal.Number.Hex */
.highlight .mi { color: #0000DD; font-weight: bold } /* Literal.Number.Integer */
.highlight .mo { color: #0000DD; font-weight: bold } /* Literal.Number.Oct */
.highlight .sa { color: #dd2200; background-color: #fff0f0 } /* Literal.String.Affix */
.highlight .sb { color: #dd2200; background-color: #fff0f0 } /* Literal.String.Backtick */
.highlight .sc { color: #dd2200; background-color: #fff0f0 } /* Literal.String.Char */
.highlight .dl { color: #dd2200; background-color: #fff0f0 } /* Literal.String.Delimiter */
.highlight .sd { color: #dd2200; background-color: #fff0f0 } /* Literal.String.Doc */
.highlight .s2 { color: #dd2200; background-color: #fff0f0 } /* Literal.String.Double */
.highlight .se { color: #0044dd; background-color: #fff0f0 } /* Literal.String.Escape */
.highlight .sh { color: #dd2200; background-color: #fff0f0 } /* Literal.String.Heredoc */
.highlight .si { color: #3333bb; background-color: #fff0f0 } /* Literal.String.Interpol */
.highlight .sx { color: #22bb22; background-color: #f0fff0 } /* Literal.String.Other */
.highlight .sr { color: #008800; background-color: #fff0ff } /* Literal.String.Regex */
.highlight .s1 { color: #dd2200; background-color: #fff0f0 } /* Literal.String.Single */
.highlight .ss { color: #aa6600; background-color: #fff0f0 } /* Literal.String.Symbol */
.highlight .bp { color: #003388 } /* Name.Builtin.Pseudo */
.highlight .fm { color: #0066bb; font-weight: bold } /* Name.Function.Magic */
.highlight .vc { color: #336699 } /* Name.Variable.Class */
.highlight .vg { color: #dd7700 } /* Name.Variable.Global */
.highlight .vi { color: #3333bb } /* Name.Variable.Instance */
.highlight .vm { color: #336699 } /* Name.Variable.Magic */
.highlight .il { color: #0000DD; font-weight: bold } /* Literal.Number.Integer.Long */</style><div class="highlight"><pre><span></span>From f90f60490c5f5f944077a42b2394c0b51c393ce1 Mon Sep 17 00:00:00 2001
From: Naushir Patuck &lt;naush@raspberrypi.com&gt;
Date: Thu, 18 Feb 2021 15:23:11 +0000
Subject: [PATCH] media: i2c: imx477: Replace existing 1012x760 mode

The existing 1012x760 120 fps mode has significant IQ problem using
the internal sensor scaler. Replace this mode with a 1332x990 120 fps
mode instead. This new mode has a smaller field of view, but does not
suffer from the bad IQ of the original mode.

Signed-off-by: Naushir Patuck &lt;naush@raspberrypi.com&gt;
<span class="gd">---</span>
 drivers/media/i2c/imx477.c | 97 ++++++++++++++++++++------------------
 1 file changed, 50 insertions(+), 47 deletions(-)

<span class="gd">--- a/drivers/media/i2c/imx477.c</span>
<span class="gi">+++ b/drivers/media/i2c/imx477.c</span>
<span class="gu">@@ -770,7 +770,7 @@ static const struct imx477_reg mode_2028</span>
 };
 
 /* 4x4 binned. 120fps */
<span class="gd">-static const struct imx477_reg mode_1012x760_regs[] = {</span>
<span class="gi">+static const struct imx477_reg mode_1332x990_regs[] = {</span>
 	{0x420b, 0x01},
 	{0x990c, 0x00},
 	{0x990d, 0x08},
<span class="gu">@@ -786,28 +786,31 @@ static const struct imx477_reg mode_1012</span>
 	{0x0112, 0x0a},
 	{0x0113, 0x0a},
 	{0x0114, 0x01},
<span class="gd">-	{0x0342, 0x14},</span>
<span class="gd">-	{0x0343, 0x60},</span>
<span class="gi">+	{0x0342, 0x1a},</span>
<span class="gi">+	{0x0343, 0x08},</span>
<span class="gi">+	{0x0340, 0x04},</span>
<span class="gi">+	{0x0341, 0x1a},</span>
 	{0x0344, 0x00},
 	{0x0345, 0x00},
<span class="gd">-	{0x0346, 0x00},</span>
<span class="gd">-	{0x0347, 0x00},</span>
<span class="gi">+	{0x0346, 0x02},</span>
<span class="gi">+	{0x0347, 0x10},</span>
 	{0x0348, 0x0f},
<span class="gd">-	{0x0349, 0xd3},</span>
<span class="gd">-	{0x034a, 0x0b},</span>
<span class="gd">-	{0x034b, 0xdf},</span>
<span class="gi">+	{0x0349, 0xd7},</span>
<span class="gi">+	{0x034a, 0x09},</span>
<span class="gi">+	{0x034b, 0xcf},</span>
 	{0x00e3, 0x00},
 	{0x00e4, 0x00},
 	{0x00fc, 0x0a},
 	{0x00fd, 0x0a},
 	{0x00fe, 0x0a},
 	{0x00ff, 0x0a},
<span class="gi">+	{0xe013, 0x00},</span>
 	{0x0220, 0x00},
 	{0x0221, 0x11},
 	{0x0381, 0x01},
 	{0x0383, 0x01},
 	{0x0385, 0x01},
<span class="gd">-	{0x0387, 0x03},</span>
<span class="gi">+	{0x0387, 0x01},</span>
 	{0x0900, 0x01},
 	{0x0901, 0x22},
 	{0x0902, 0x02},
<span class="gu">@@ -831,29 +834,29 @@ static const struct imx477_reg mode_1012</span>
 	{0x936d, 0x5f},
 	{0x9304, 0x03},
 	{0x9305, 0x80},
<span class="gd">-	{0x9e9a, 0x3f},</span>
<span class="gd">-	{0x9e9b, 0x3f},</span>
<span class="gd">-	{0x9e9c, 0x3f},</span>
<span class="gd">-	{0x9e9d, 0x27},</span>
<span class="gd">-	{0x9e9e, 0x27},</span>
<span class="gd">-	{0x9e9f, 0x27},</span>
<span class="gi">+	{0x9e9a, 0x2f},</span>
<span class="gi">+	{0x9e9b, 0x2f},</span>
<span class="gi">+	{0x9e9c, 0x2f},</span>
<span class="gi">+	{0x9e9d, 0x00},</span>
<span class="gi">+	{0x9e9e, 0x00},</span>
<span class="gi">+	{0x9e9f, 0x00},</span>
 	{0xa2a9, 0x27},
 	{0xa2b7, 0x03},
<span class="gd">-	{0x0401, 0x01},</span>
<span class="gi">+	{0x0401, 0x00},</span>
 	{0x0404, 0x00},
<span class="gd">-	{0x0405, 0x20},</span>
<span class="gd">-	{0x0408, 0x00},</span>
<span class="gd">-	{0x0409, 0x00},</span>
<span class="gi">+	{0x0405, 0x10},</span>
<span class="gi">+	{0x0408, 0x01},</span>
<span class="gi">+	{0x0409, 0x5c},</span>
 	{0x040a, 0x00},
 	{0x040b, 0x00},
<span class="gd">-	{0x040c, 0x07},</span>
<span class="gd">-	{0x040d, 0xea},</span>
<span class="gd">-	{0x040e, 0x02},</span>
<span class="gd">-	{0x040f, 0xf8},</span>
<span class="gd">-	{0x034c, 0x03},</span>
<span class="gd">-	{0x034d, 0xf4},</span>
<span class="gd">-	{0x034e, 0x02},</span>
<span class="gd">-	{0x034f, 0xf8},</span>
<span class="gi">+	{0x040c, 0x05},</span>
<span class="gi">+	{0x040d, 0x34},</span>
<span class="gi">+	{0x040e, 0x03},</span>
<span class="gi">+	{0x040f, 0xde},</span>
<span class="gi">+	{0x034c, 0x05},</span>
<span class="gi">+	{0x034d, 0x34},</span>
<span class="gi">+	{0x034e, 0x03},</span>
<span class="gi">+	{0x034f, 0xde},</span>
 	{0x0301, 0x05},
 	{0x0303, 0x02},
 	{0x0305, 0x02},
<span class="gu">@@ -870,21 +873,21 @@ static const struct imx477_reg mode_1012</span>
 	{0x0822, 0x00},
 	{0x0823, 0x00},
 	{0x080a, 0x00},
<span class="gd">-	{0x080b, 0x6f},</span>
<span class="gi">+	{0x080b, 0x7f},</span>
 	{0x080c, 0x00},
<span class="gd">-	{0x080d, 0x3f},</span>
<span class="gi">+	{0x080d, 0x4f},</span>
 	{0x080e, 0x00},
<span class="gd">-	{0x080f, 0xff},</span>
<span class="gi">+	{0x080f, 0x77},</span>
 	{0x0810, 0x00},
<span class="gd">-	{0x0811, 0x4f},</span>
<span class="gi">+	{0x0811, 0x5f},</span>
 	{0x0812, 0x00},
<span class="gd">-	{0x0813, 0x47},</span>
<span class="gi">+	{0x0813, 0x57},</span>
 	{0x0814, 0x00},
<span class="gd">-	{0x0815, 0x37},</span>
<span class="gd">-	{0x0816, 0x00},</span>
<span class="gd">-	{0x0817, 0xe7},</span>
<span class="gi">+	{0x0815, 0x4f},</span>
<span class="gi">+	{0x0816, 0x01},</span>
<span class="gi">+	{0x0817, 0x27},</span>
 	{0x0818, 0x00},
<span class="gd">-	{0x0819, 0x2f},</span>
<span class="gi">+	{0x0819, 0x3f},</span>
 	{0xe04c, 0x00},
 	{0xe04d, 0x5f},
 	{0xe04e, 0x00},
<span class="gu">@@ -893,7 +896,7 @@ static const struct imx477_reg mode_1012</span>
 	{0x3e37, 0x00},
 	{0x3f50, 0x00},
 	{0x3f56, 0x00},
<span class="gd">-	{0x3f57, 0x96},</span>
<span class="gi">+	{0x3f57, 0xbf},</span>
 };
 
 /* Mode configs */
<span class="gu">@@ -974,9 +977,9 @@ static const struct imx477_mode supporte</span>
 
 static const struct imx477_mode supported_modes_10bit[] = {
 	{
<span class="gd">-		/* 720P 120fps. 4x4 binned */</span>
<span class="gd">-		.width = 1012,</span>
<span class="gd">-		.height = 760,</span>
<span class="gi">+		/* 120fps. 2x2 binned and cropped */</span>
<span class="gi">+		.width = 1332,</span>
<span class="gi">+		.height = 990,</span>
 		.line_length_pix = 0x1460,
 		.crop = {
 			/*
<span class="gu">@@ -987,10 +990,10 @@ static const struct imx477_mode supporte</span>
 			 * rectangle once the driver is expanded to represent
 			 * its processing blocks with multiple subdevs.
 			 */
<span class="gd">-			.left = IMX477_PIXEL_ARRAY_LEFT + 4,</span>
<span class="gd">-			.top = IMX477_PIXEL_ARRAY_TOP,</span>
<span class="gd">-			.width = 4052,</span>
<span class="gd">-			.height = 3040,</span>
<span class="gi">+			.left = IMX477_PIXEL_ARRAY_LEFT + 696,</span>
<span class="gi">+			.top = IMX477_PIXEL_ARRAY_TOP + 528,</span>
<span class="gi">+			.width = 2664,</span>
<span class="gi">+			.height = 1980,</span>
 		},
 		.timeperframe_min = {
 			.numerator = 100,
<span class="gu">@@ -998,11 +1001,11 @@ static const struct imx477_mode supporte</span>
 		},
 		.timeperframe_default = {
 			.numerator = 100,
<span class="gd">-			.denominator = 60000</span>
<span class="gi">+			.denominator = 12000</span>
 		},
 		.reg_list = {
<span class="gd">-			.num_of_regs = ARRAY_SIZE(mode_1012x760_regs),</span>
<span class="gd">-			.regs = mode_1012x760_regs,</span>
<span class="gi">+			.num_of_regs = ARRAY_SIZE(mode_1332x990_regs),</span>
<span class="gi">+			.regs = mode_1332x990_regs,</span>
 		}
 	}
 };
</pre></div>
</code></pre></td></tr></table>
</div> <!-- class=content -->
<div class='footer'>generated by <a href='https://git.zx2c4.com/cgit/about/'>cgit v1.2.3</a> (<a href='https://git-scm.com/'>git 2.25.1</a>) at 2024-07-25 15:19:43 +0000</div>
</div> <!-- id=cgit -->
</body>
</html>