Content-Security-Policy: default-src 'none'
Content-Type: text/plain; charset=UTF-8
Content-Length: 2546
Content-Disposition: inline; filename="950-0371-phy-broadcom-split-out-the-BCM54213PE-from-the-BCM54.patch"
Last-Modified: Fri, 07 Feb 2025 23:14:46 GMT
Expires: Mon, 05 Feb 2035 23:14:46 GMT
ETag: "4fbb4d6594ea4819444cd35f9aff3ccf1b701f71"

From 7b0e9b30aaf78bddfcb589be0686846076f23f62 Mon Sep 17 00:00:00 2001
From: Jonathan Bell <jonathan@raspberrypi.org>
Date: Tue, 14 May 2019 17:00:41 +0100
Subject: [PATCH] phy: broadcom: split out the BCM54213PE from the
 BCM54210E IDs

The last nibble is a revision ID, and the 54213pe is a later rev
than the 54210e. Running the 54210e setup code on a 54213pe results
in a broken RGMII interface.

Signed-off-by: Jonathan Bell <jonathan@raspberrypi.org>
---
 drivers/net/phy/broadcom.c | 16 +++++++++++++---
 include/linux/brcmphy.h    |  1 +
 2 files changed, 14 insertions(+), 3 deletions(-)

--- a/drivers/net/phy/broadcom.c
+++ b/drivers/net/phy/broadcom.c
@@ -252,7 +252,8 @@ static void bcm54xx_adjust_rxrefclk(stru
 	    BRCM_PHY_MODEL(phydev) != PHY_ID_BCM50610 &&
 	    BRCM_PHY_MODEL(phydev) != PHY_ID_BCM50610M &&
 	    BRCM_PHY_MODEL(phydev) != PHY_ID_BCM54810 &&
-	    BRCM_PHY_MODEL(phydev) != PHY_ID_BCM54811)
+	    BRCM_PHY_MODEL(phydev) != PHY_ID_BCM54811 &&
+	    BRCM_PHY_MODEL(phydev) != PHY_ID_BCM54213PE)
 		return;
 
 	val = bcm_phy_read_shadow(phydev, BCM54XX_SHD_SCR3);
@@ -763,13 +764,21 @@ static struct phy_driver broadcom_driver
 	.config_intr	= bcm_phy_config_intr,
 }, {
 	.phy_id		= PHY_ID_BCM54210E,
-	.phy_id_mask	= 0xfffffff0,
+	.phy_id_mask	= 0xffffffff,
 	.name		= "Broadcom BCM54210E",
 	/* PHY_GBIT_FEATURES */
 	.config_init	= bcm54xx_config_init,
 	.ack_interrupt	= bcm_phy_ack_intr,
 	.config_intr	= bcm_phy_config_intr,
 }, {
+	.phy_id		= PHY_ID_BCM54213PE,
+	.phy_id_mask	= 0xffffffff,
+	.name		= "Broadcom BCM54213PE",
+	/* PHY_GBIT_FEATURES */
+	.config_init	= bcm54xx_config_init,
+	.ack_interrupt	= bcm_phy_ack_intr,
+	.config_intr	= bcm_phy_config_intr,
+}, {
 	.phy_id		= PHY_ID_BCM5461,
 	.phy_id_mask	= 0xfffffff0,
 	.name		= "Broadcom BCM5461",
@@ -924,7 +933,8 @@ module_phy_driver(broadcom_drivers);
 static struct mdio_device_id __maybe_unused broadcom_tbl[] = {
 	{ PHY_ID_BCM5411, 0xfffffff0 },
 	{ PHY_ID_BCM5421, 0xfffffff0 },
-	{ PHY_ID_BCM54210E, 0xfffffff0 },
+	{ PHY_ID_BCM54210E, 0xffffffff },
+	{ PHY_ID_BCM54213PE, 0xffffffff },
 	{ PHY_ID_BCM5461, 0xfffffff0 },
 	{ PHY_ID_BCM54612E, 0xfffffff0 },
 	{ PHY_ID_BCM54616S, 0xfffffff0 },
--- a/include/linux/brcmphy.h
+++ b/include/linux/brcmphy.h
@@ -22,6 +22,7 @@
 #define PHY_ID_BCM5411			0x00206070
 #define PHY_ID_BCM5421			0x002060e0
 #define PHY_ID_BCM54210E		0x600d84a0
+#define PHY_ID_BCM54213PE		0x600d84a2
 #define PHY_ID_BCM5464			0x002060b0
 #define PHY_ID_BCM5461			0x002060c0
 #define PHY_ID_BCM54612E		0x03625e60
03.4&amp;id=a328b6831c0f1e47e4fd4da4e00c0b9cb53cf2e4'>commit</a><a href='/cgit.cgi/openwrt/upstream/diff/target/linux/bcm27xx/patches-5.10/950-0675-drm-vc4-hdmi-Drop-devm-interrupt-handler-for-CEC-int.patch?h=v22.03.4&amp;id=a328b6831c0f1e47e4fd4da4e00c0b9cb53cf2e4'>diff</a><a href='/cgit.cgi/openwrt/upstream/stats/target/linux/bcm27xx/patches-5.10/950-0675-drm-vc4-hdmi-Drop-devm-interrupt-handler-for-CEC-int.patch?h=v22.03.4'>stats</a></td><td class='form'><form class='right' method='get' action='/cgit.cgi/openwrt/upstream/log/target/linux/bcm27xx/patches-5.10/950-0675-drm-vc4-hdmi-Drop-devm-interrupt-handler-for-CEC-int.patch'>
<input type='hidden' name='h' value='v22.03.4'/><input type='hidden' name='id' value='a328b6831c0f1e47e4fd4da4e00c0b9cb53cf2e4'/><select name='qt'>
<option value='grep'>log msg</option>
<option value='author'>author</option>
<option value='committer'>committer</option>
<option value='range'>range</option>
</select>
<input class='txt' type='search' size='10' name='q' value=''/>
<input type='submit' value='search'/>
</form>
</td></tr></table>
<div class='path'>path: <a href='/cgit.cgi/openwrt/upstream/tree/?h=v22.03.4&amp;id=a328b6831c0f1e47e4fd4da4e00c0b9cb53cf2e4'>root</a>/<a href='/cgit.cgi/openwrt/upstream/tree/target?h=v22.03.4&amp;id=a328b6831c0f1e47e4fd4da4e00c0b9cb53cf2e4'>target</a>/<a href='/cgit.cgi/openwrt/upstream/tree/target/linux?h=v22.03.4&amp;id=a328b6831c0f1e47e4fd4da4e00c0b9cb53cf2e4'>linux</a>/<a href='/cgit.cgi/openwrt/upstream/tree/target/linux/bcm27xx?h=v22.03.4&amp;id=a328b6831c0f1e47e4fd4da4e00c0b9cb53cf2e4'>bcm27xx</a>/<a href='/cgit.cgi/openwrt/upstream/tree/target/linux/bcm27xx/patches-5.10?h=v22.03.4&amp;id=a328b6831c0f1e47e4fd4da4e00c0b9cb53cf2e4'>patches-5.10</a>/<a href='/cgit.cgi/openwrt/upstream/tree/target/linux/bcm27xx/patches-5.10/950-0675-drm-vc4-hdmi-Drop-devm-interrupt-handler-for-CEC-int.patch?h=v22.03.4&amp;id=a328b6831c0f1e47e4fd4da4e00c0b9cb53cf2e4'>950-0675-drm-vc4-hdmi-Drop-devm-interrupt-handler-for-CEC-int.patch</a></div><div class='content'>blob: e436a0e54bec0a35a0eb3bcb47472a1175397b16 (<a href='/cgit.cgi/openwrt/upstream/plain/target/linux/bcm27xx/patches-5.10/950-0675-drm-vc4-hdmi-Drop-devm-interrupt-handler-for-CEC-int.patch?h=v22.03.4&amp;id=a328b6831c0f1e47e4fd4da4e00c0b9cb53cf2e4'>plain</a>)
<table summary='blob content' class='blob'>
<tr><td class='linenumbers'><pre><a id='n1' href='#n1'>1</a>
<a id='n2' href='#n2'>2</a>
<a id='n3' href='#n3'>3</a>
<a id='n4' href='#n4'>4</a>
<a id='n5' href='#n5'>5</a>
<a id='n6' href='#n6'>6</a>
<a id='n7' href='#n7'>7</a>
<a id='n8' href='#n8'>8</a>
<a id='n9' href='#n9'>9</a>
<a id='n10' href='#n10'>10</a>
<a id='n11' href='#n11'>11</a>
<a id='n12' href='#n12'>12</a>
<a id='n13' href='#n13'>13</a>
<a id='n14' href='#n14'>14</a>
<a id='n15' href='#n15'>15</a>
<a id='n16' href='#n16'>16</a>
<a id='n17' href='#n17'>17</a>
<a id='n18' href='#n18'>18</a>
<a id='n19' href='#n19'>19</a>
<a id='n20' href='#n20'>20</a>
<a id='n21' href='#n21'>21</a>
<a id='n22' href='#n22'>22</a>
<a id='n23' href='#n23'>23</a>
<a id='n24' href='#n24'>24</a>
<a id='n25' href='#n25'>25</a>
<a id='n26' href='#n26'>26</a>
<a id='n27' href='#n27'>27</a>
<a id='n28' href='#n28'>28</a>
<a id='n29' href='#n29'>29</a>
<a id='n30' href='#n30'>30</a>
<a id='n31' href='#n31'>31</a>
<a id='n32' href='#n32'>32</a>
<a id='n33' href='#n33'>33</a>
<a id='n34' href='#n34'>34</a>
<a id='n35' href='#n35'>35</a>
<a id='n36' href='#n36'>36</a>
<a id='n37' href='#n37'>37</a>
<a id='n38' href='#n38'>38</a>
<a id='n39' href='#n39'>39</a>
<a id='n40' href='#n40'>40</a>
<a id='n41' href='#n41'>41</a>
<a id='n42' href='#n42'>42</a>
<a id='n43' href='#n43'>43</a>
<a id='n44' href='#n44'>44</a>
<a id='n45' href='#n45'>45</a>
<a id='n46' href='#n46'>46</a>
<a id='n47' href='#n47'>47</a>
<a id='n48' href='#n48'>48</a>
<a id='n49' href='#n49'>49</a>
<a id='n50' href='#n50'>50</a>
<a id='n51' href='#n51'>51</a>
<a id='n52' href='#n52'>52</a>
<a id='n53' href='#n53'>53</a>
<a id='n54' href='#n54'>54</a>
<a id='n55' href='#n55'>55</a>
<a id='n56' href='#n56'>56</a>
<a id='n57' href='#n57'>57</a>
<a id='n58' href='#n58'>58</a>
<a id='n59' href='#n59'>59</a>
<a id='n60' href='#n60'>60</a>
<a id='n61' href='#n61'>61</a>
<a id='n62' href='#n62'>62</a>
<a id='n63' href='#n63'>63</a>
<a id='n64' href='#n64'>64</a>
<a id='n65' href='#n65'>65</a>
<a id='n66' href='#n66'>66</a>
<a id='n67' href='#n67'>67</a>
<a id='n68' href='#n68'>68</a>
<a id='n69' href='#n69'>69</a>
<a id='n70' href='#n70'>70</a>
<a id='n71' href='#n71'>71</a>
<a id='n72' href='#n72'>72</a>
<a id='n73' href='#n73'>73</a>
<a id='n74' href='#n74'>74</a>
<a id='n75' href='#n75'>75</a>
<a id='n76' href='#n76'>76</a>
<a id='n77' href='#n77'>77</a>
<a id='n78' href='#n78'>78</a>
<a id='n79' href='#n79'>79</a>
<a id='n80' href='#n80'>80</a>
<a id='n81' href='#n81'>81</a>
<a id='n82' href='#n82'>82</a>
<a id='n83' href='#n83'>83</a>
<a id='n84' href='#n84'>84</a>
<a id='n85' href='#n85'>85</a>
<a id='n86' href='#n86'>86</a>
<a id='n87' href='#n87'>87</a>
<a id='n88' href='#n88'>88</a>
<a id='n89' href='#n89'>89</a>
<a id='n90' href='#n90'>90</a>
<a id='n91' href='#n91'>91</a>
<a id='n92' href='#n92'>92</a>
<a id='n93' href='#n93'>93</a>
<a id='n94' href='#n94'>94</a>
<a id='n95' href='#n95'>95</a>
<a id='n96' href='#n96'>96</a>
<a id='n97' href='#n97'>97</a>
<a id='n98' href='#n98'>98</a>
<a id='n99' href='#n99'>99</a>
<a id='n100' href='#n100'>100</a>
<a id='n101' href='#n101'>101</a>
<a id='n102' href='#n102'>102</a>
<a id='n103' href='#n103'>103</a>
<a id='n104' href='#n104'>104</a>
<a id='n105' href='#n105'>105</a>
<a id='n106' href='#n106'>106</a>
</pre></td>
<td class='lines'><pre><code><style>pre { line-height: 125%; margin: 0; }
td.linenos pre { color: #000000; background-color: #f0f0f0; padding: 0 5px 0 5px; }
span.linenos { color: #000000; background-color: #f0f0f0; padding: 0 5px 0 5px; }
td.linenos pre.special { color: #000000; background-color: #ffffc0; padding: 0 5px 0 5px; }
span.linenos.special { color: #000000; background-color: #ffffc0; padding: 0 5px 0 5px; }
.highlight .hll { background-color: #ffffcc }
.highlight { background: #ffffff; }
.highlight .c { color: #888888 } /* Comment */
.highlight .err { color: #a61717; background-color: #e3d2d2 } /* Error */
.highlight .k { color: #008800; font-weight: bold } /* Keyword */
.highlight .ch { color: #888888 } /* Comment.Hashbang */
.highlight .cm { color: #888888 } /* Comment.Multiline */
.highlight .cp { color: #cc0000; font-weight: bold } /* Comment.Preproc */
.highlight .cpf { color: #888888 } /* Comment.PreprocFile */
.highlight .c1 { color: #888888 } /* Comment.Single */
.highlight .cs { color: #cc0000; font-weight: bold; background-color: #fff0f0 } /* Comment.Special */
.highlight .gd { color: #000000; background-color: #ffdddd } /* Generic.Deleted */
.highlight .ge { font-style: italic } /* Generic.Emph */
.highlight .gr { color: #aa0000 } /* Generic.Error */
.highlight .gh { color: #333333 } /* Generic.Heading */
.highlight .gi { color: #000000; background-color: #ddffdd } /* Generic.Inserted */
.highlight .go { color: #888888 } /* Generic.Output */
.highlight .gp { color: #555555 } /* Generic.Prompt */
.highlight .gs { font-weight: bold } /* Generic.Strong */
.highlight .gu { color: #666666 } /* Generic.Subheading */
.highlight .gt { color: #aa0000 } /* Generic.Traceback */
.highlight .kc { color: #008800; font-weight: bold } /* Keyword.Constant */
.highlight .kd { color: #008800; font-weight: bold } /* Keyword.Declaration */
.highlight .kn { color: #008800; font-weight: bold } /* Keyword.Namespace */
.highlight .kp { color: #008800 } /* Keyword.Pseudo */
.highlight .kr { color: #008800; font-weight: bold } /* Keyword.Reserved */
.highlight .kt { color: #888888; font-weight: bold } /* Keyword.Type */
.highlight .m { color: #0000DD; font-weight: bold } /* Literal.Number */
.highlight .s { color: #dd2200; background-color: #fff0f0 } /* Literal.String */
.highlight .na { color: #336699 } /* Name.Attribute */
.highlight .nb { color: #003388 } /* Name.Builtin */
.highlight .nc { color: #bb0066; font-weight: bold } /* Name.Class */
.highlight .no { color: #003366; font-weight: bold } /* Name.Constant */
.highlight .nd { color: #555555 } /* Name.Decorator */
.highlight .ne { color: #bb0066; font-weight: bold } /* Name.Exception */
.highlight .nf { color: #0066bb; font-weight: bold } /* Name.Function */
.highlight .nl { color: #336699; font-style: italic } /* Name.Label */
.highlight .nn { color: #bb0066; font-weight: bold } /* Name.Namespace */
.highlight .py { color: #336699; font-weight: bold } /* Name.Property */
.highlight .nt { color: #bb0066; font-weight: bold } /* Name.Tag */
.highlight .nv { color: #336699 } /* Name.Variable */
.highlight .ow { color: #008800 } /* Operator.Word */
.highlight .w { color: #bbbbbb } /* Text.Whitespace */
.highlight .mb { color: #0000DD; font-weight: bold } /* Literal.Number.Bin */
.highlight .mf { color: #0000DD; font-weight: bold } /* Literal.Number.Float */
.highlight .mh { color: #0000DD; font-weight: bold } /* Literal.Number.Hex */
.highlight .mi { color: #0000DD; font-weight: bold } /* Literal.Number.Integer */
.highlight .mo { color: #0000DD; font-weight: bold } /* Literal.Number.Oct */
.highlight .sa { color: #dd2200; background-color: #fff0f0 } /* Literal.String.Affix */
.highlight .sb { color: #dd2200; background-color: #fff0f0 } /* Literal.String.Backtick */
.highlight .sc { color: #dd2200; background-color: #fff0f0 } /* Literal.String.Char */
.highlight .dl { color: #dd2200; background-color: #fff0f0 } /* Literal.String.Delimiter */
.highlight .sd { color: #dd2200; background-color: #fff0f0 } /* Literal.String.Doc */
.highlight .s2 { color: #dd2200; background-color: #fff0f0 } /* Literal.String.Double */
.highlight .se { color: #0044dd; background-color: #fff0f0 } /* Literal.String.Escape */
.highlight .sh { color: #dd2200; background-color: #fff0f0 } /* Literal.String.Heredoc */
.highlight .si { color: #3333bb; background-color: #fff0f0 } /* Literal.String.Interpol */
.highlight .sx { color: #22bb22; background-color: #f0fff0 } /* Literal.String.Other */
.highlight .sr { color: #008800; background-color: #fff0ff } /* Literal.String.Regex */
.highlight .s1 { color: #dd2200; background-color: #fff0f0 } /* Literal.String.Single */
.highlight .ss { color: #aa6600; background-color: #fff0f0 } /* Literal.String.Symbol */
.highlight .bp { color: #003388 } /* Name.Builtin.Pseudo */
.highlight .fm { color: #0066bb; font-weight: bold } /* Name.Function.Magic */
.highlight .vc { color: #336699 } /* Name.Variable.Class */
.highlight .vg { color: #dd7700 } /* Name.Variable.Global */
.highlight .vi { color: #3333bb } /* Name.Variable.Instance */
.highlight .vm { color: #336699 } /* Name.Variable.Magic */
.highlight .il { color: #0000DD; font-weight: bold } /* Literal.Number.Integer.Long */</style><div class="highlight"><pre><span></span>From 687a0fc86f37e0bc74c8382c0d89b0929fade1de Mon Sep 17 00:00:00 2001
From: Maxime Ripard &lt;maxime@cerno.tech&gt;
Date: Mon, 5 Jul 2021 15:47:43 +0200
Subject: [PATCH] drm/vc4: hdmi: Drop devm interrupt handler for CEC
 interrupts

The CEC interrupt handlers are registered through the
devm_request_threaded_irq function. However, while free_irq is indeed
called properly when the device is unbound or bind fails, it&#39;s called
after unbind or bind is done.

In our particular case, it means that on failure it creates a window
where our interrupt handler can be called, but we&#39;re freeing every
resource (CEC adapter, DRM objects, etc.) it might need.

In order to address this, let&#39;s switch to the non-devm variant to
control better when the handler will be unregistered and allow us to
make it safe.

Fixes: 15b4511a4af6 (&quot;drm/vc4: add HDMI CEC support&quot;)
Signed-off-by: Maxime Ripard &lt;maxime@cerno.tech&gt;
<span class="gd">---</span>
 drivers/gpu/drm/vc4/vc4_hdmi.c | 49 +++++++++++++++++++++++-----------
 1 file changed, 33 insertions(+), 16 deletions(-)

<span class="gd">--- a/drivers/gpu/drm/vc4/vc4_hdmi.c</span>
<span class="gi">+++ b/drivers/gpu/drm/vc4/vc4_hdmi.c</span>
<span class="gu">@@ -1903,38 +1903,46 @@ static int vc4_hdmi_cec_init(struct vc4_</span>
 	vc4_hdmi_cec_update_clk_div(vc4_hdmi);
 
 	if (vc4_hdmi-&gt;variant-&gt;external_irq_controller) {
<span class="gd">-		ret = devm_request_threaded_irq(&amp;pdev-&gt;dev,</span>
<span class="gd">-						platform_get_irq_byname(pdev, &quot;cec-rx&quot;),</span>
<span class="gd">-						vc4_cec_irq_handler_rx_bare,</span>
<span class="gd">-						vc4_cec_irq_handler_rx_thread, 0,</span>
<span class="gd">-						&quot;vc4 hdmi cec rx&quot;, vc4_hdmi);</span>
<span class="gi">+		ret = request_threaded_irq(platform_get_irq_byname(pdev, &quot;cec-rx&quot;),</span>
<span class="gi">+					   vc4_cec_irq_handler_rx_bare,</span>
<span class="gi">+					   vc4_cec_irq_handler_rx_thread, 0,</span>
<span class="gi">+					   &quot;vc4 hdmi cec rx&quot;, vc4_hdmi);</span>
 		if (ret)
 			goto err_delete_cec_adap;
 
<span class="gd">-		ret = devm_request_threaded_irq(&amp;pdev-&gt;dev,</span>
<span class="gd">-						platform_get_irq_byname(pdev, &quot;cec-tx&quot;),</span>
<span class="gd">-						vc4_cec_irq_handler_tx_bare,</span>
<span class="gd">-						vc4_cec_irq_handler_tx_thread, 0,</span>
<span class="gd">-						&quot;vc4 hdmi cec tx&quot;, vc4_hdmi);</span>
<span class="gi">+		ret = request_threaded_irq(platform_get_irq_byname(pdev, &quot;cec-tx&quot;),</span>
<span class="gi">+					   vc4_cec_irq_handler_tx_bare,</span>
<span class="gi">+					   vc4_cec_irq_handler_tx_thread, 0,</span>
<span class="gi">+					   &quot;vc4 hdmi cec tx&quot;, vc4_hdmi);</span>
 		if (ret)
<span class="gd">-			goto err_delete_cec_adap;</span>
<span class="gi">+			goto err_remove_cec_rx_handler;</span>
 	} else {
 		HDMI_WRITE(HDMI_CEC_CPU_MASK_SET, 0xffffffff);
 
<span class="gd">-		ret = devm_request_threaded_irq(&amp;pdev-&gt;dev, platform_get_irq(pdev, 0),</span>
<span class="gd">-						vc4_cec_irq_handler,</span>
<span class="gd">-						vc4_cec_irq_handler_thread, 0,</span>
<span class="gd">-						&quot;vc4 hdmi cec&quot;, vc4_hdmi);</span>
<span class="gi">+		ret = request_threaded_irq(platform_get_irq(pdev, 0),</span>
<span class="gi">+					   vc4_cec_irq_handler,</span>
<span class="gi">+					   vc4_cec_irq_handler_thread, 0,</span>
<span class="gi">+					   &quot;vc4 hdmi cec&quot;, vc4_hdmi);</span>
 		if (ret)
 			goto err_delete_cec_adap;
 	}
 
 	ret = cec_register_adapter(vc4_hdmi-&gt;cec_adap, &amp;pdev-&gt;dev);
 	if (ret &lt; 0)
<span class="gd">-		goto err_delete_cec_adap;</span>
<span class="gi">+		goto err_remove_handlers;</span>
 
 	return 0;
 
<span class="gi">+err_remove_handlers:</span>
<span class="gi">+	if (vc4_hdmi-&gt;variant-&gt;external_irq_controller)</span>
<span class="gi">+		free_irq(platform_get_irq_byname(pdev, &quot;cec-tx&quot;), vc4_hdmi);</span>
<span class="gi">+	else</span>
<span class="gi">+		free_irq(platform_get_irq(pdev, 0), vc4_hdmi);</span>
<span class="gi">+</span>
<span class="gi">+err_remove_cec_rx_handler:</span>
<span class="gi">+	if (vc4_hdmi-&gt;variant-&gt;external_irq_controller)</span>
<span class="gi">+		free_irq(platform_get_irq_byname(pdev, &quot;cec-rx&quot;), vc4_hdmi);</span>
<span class="gi">+</span>
 err_delete_cec_adap:
 	cec_delete_adapter(vc4_hdmi-&gt;cec_adap);
 
<span class="gu">@@ -1943,6 +1951,15 @@ err_delete_cec_adap:</span>
 
 static void vc4_hdmi_cec_exit(struct vc4_hdmi *vc4_hdmi)
 {
<span class="gi">+	struct platform_device *pdev = vc4_hdmi-&gt;pdev;</span>
<span class="gi">+</span>
<span class="gi">+	if (vc4_hdmi-&gt;variant-&gt;external_irq_controller) {</span>
<span class="gi">+		free_irq(platform_get_irq_byname(pdev, &quot;cec-rx&quot;), vc4_hdmi);</span>
<span class="gi">+		free_irq(platform_get_irq_byname(pdev, &quot;cec-tx&quot;), vc4_hdmi);</span>
<span class="gi">+	} else {</span>
<span class="gi">+		free_irq(platform_get_irq(pdev, 0), vc4_hdmi);</span>
<span class="gi">+	}</span>
<span class="gi">+</span>
 	cec_unregister_adapter(vc4_hdmi-&gt;cec_adap);
 }
 #else
</pre></div>
</code></pre></td></tr></table>
</div> <!-- class=content -->
<div class='footer'>generated by <a href='https://git.zx2c4.com/cgit/about/'>cgit v1.2.3</a> (<a href='https://git-scm.com/'>git 2.25.1</a>) at 2025-02-07 23:14:46 +0000</div>
</div> <!-- id=cgit -->
</body>
</html>